/*using Labelling.dta*
*1. reverses scores for SD, PR, NA scales
2. looks for missing data
3. prorates for MEAN scores for SD, PR, LB, NA scales on all vignettes
4. generates contact, age group, gender variables
5. generates disclosure/nondisclosure variables*/

*INSTALL: misschk*

*REVERSE*

*reverse code questions in Sam NT scales, rename so clear these are reversed
*social distance q: 2,3,5,7. max score on each question is 5*
*SOCIAL DISTANCE - high is BAD*
replace S_SD1 = 6 - S_SD1
rename S_SD1 S_SD1_R
replace S_SD4 = 6 - S_SD4
rename S_SD4 S_SD4_R
replace S_SD6 = 6 - S_SD6
rename S_SD6 S_SD6_R
replace S_SD8 = 6 - S_SD8
rename S_SD8 S_SD8_R

*personal responsibility q: 3,4. max score on each question is 5*
*PR - high is BAD*
replace S_PR3 = 6 - S_PR3
rename S_PR3 S_PR3_R
replace S_PR4 = 6 - S_PR4
rename S_PR4 S_PR4_R

*likelihood bullying don't need reversing*
*LB - high is BAD*

*negative affect q: 1,3,4,6. max score on each question is 5*
*NA - high is BAD*
replace S_NA2 = 6 - S_NA2
rename S_NA2 S_NA2_R
replace S_NA5 = 6 - S_NA5
rename S_NA5 S_NA5_R

*reverse scores for Alex ASD*
replace A_SD1 = 6 - A_SD1
rename A_SD1 A_SD1_R
replace A_SD4 = 6 - A_SD4
rename A_SD4 A_SD4_R
replace A_SD6 = 6 - A_SD6
rename A_SD6 A_SD6_R
replace A_SD8 = 6 - A_SD8
rename A_SD8 A_SD8_R

replace A_PR3 = 6 - A_PR3
rename A_PR3 A_PR3_R
replace A_PR4 = 6 - A_PR4
rename A_PR4 A_PR4_R

replace A_NA2 = 6 - A_NA2
rename A_NA2 A_NA2_R
replace A_NA5 = 6 - A_NA5
rename A_NA5 A_NA5_R

*reverse scores for George ADHD*
replace G_SD1 = 6 - G_SD1
rename G_SD1 G_SD1_R
replace G_SD4 = 6 - G_SD4
rename G_SD4 G_SD4_R
replace G_SD6 = 6 - G_SD6
rename G_SD6 G_SD6_R
replace G_SD8 = 6 - G_SD8
rename G_SD8 G_SD8_R

replace G_PR3 = 6 - G_PR3
rename G_PR3 G_PR3_R
replace G_PR4 = 6 - G_PR4
rename G_PR4 G_PR4_R

replace G_NA2 = 6 - G_NA2
rename G_NA2 G_NA2_R
replace G_NA5 = 6 - G_NA5
rename G_NA5 G_NA5_R


*MISSING RAW SCORES*
*numbers missing data by observation*
egen nmis=rmiss( ASN ASNO ASNO_Who ASNO_Time ASNO_Quality S_SD1_R S_SD2 S_SD3 S_SD4_R S_SD5 S_SD6_R S_SD7 S_SD8_R S_PR1 S_PR2 S_PR3_R S_PR4_R S_LB1 S_LB2 S_LB3 S_LB4 S_LB5 S_NA1 S_NA2_R S_NA3 S_NA4 S_NA5_R S_NA6 A_SD1_R A_SD2 A_SD3 A_SD4_R A_SD5 A_SD6_R A_SD7 A_SD8_R A_PR1 A_PR2 A_PR3_R A_PR4_R A_LB1 A_LB2 A_LB3 A_LB4 A_LB5 A_NA1 A_NA2_R A_NA3 A_NA4 A_NA5_R A_NA6 G_SD1_R G_SD2 G_SD3 G_SD4_R G_SD5 G_SD6_R G_SD7 G_SD8_R G_PR1 G_PR2 G_PR3_R G_PR4_R G_LB1 G_LB2 G_LB3 G_LB4 G_LB5 G_NA1 G_NA2_R G_NA3 G_NA4 G_NA5_R G_NA6)

/* *use misschk command to generate useful tables and patterns of missing data* 
*SD and NA scales have been REORDERED since!*
search misschk
*install misschk*
*patterns of missing data for Sam (NT)*
 misschk S_SD1 S_SD2_R S_SD3_R S_SD4 S_SD5_R S_SD6 S_SD7_R S_SD8
 misschk S_PR1 S_PR2 S_PR3_R S_PR4_R
 misschk S_LB1 S_LB2 S_LB3 S_LB4 S_LB5
 misschk S_NA1_R S_NA2 S_NA3_R S_NA4_R S_NA5 S_NA6_R
 *Alex (ASD)*
 misschk A_SD1 A_SD2_R A_SD3_R A_SD4 A_SD5_R A_SD6 A_SD7_R A_SD8
 misschk A_PR1 A_PR2 A_PR3_R A_PR4_R
 misschk A_LB1 A_LB2 A_LB3 A_LB4 A_LB5
 misschk A_NA1_R A_NA2 A_NA3_R A_NA4_R A_NA5 A_NA6_R
 *George (ADHD)*
 misschk G_SD1 G_SD2_R G_SD3_R G_SD4 G_SD5_R G_SD6 G_SD7_R G_SD8
 misschk G_PR1 G_PR2 G_PR3_R G_PR4_R
 misschk G_LB1 G_LB2 G_LB3 G_LB4 G_LB5
 misschk G_NA1_R G_NA2 G_NA3_R G_NA4_R G_NA5 G_NA6_R
*/

*missing for S and A (NT & ASD) SD, PR, NA scales*
*using reordered*
misschk S_SD1_R-S_PR4_R S_NA1-S_NA6 A_SD1_R-A_PR4_R A_NA1-A_NA6
*compared to just A (ASD)*
misschk A_SD1_R-A_PR4_R A_NA1-A_NA6
*missing for S & A for SD, PR, NA, Gender, Age, ASN*
misschk S_SD1_R-S_PR4_R S_NA1-S_NA6 A_SD1_R-A_PR4_R A_NA1-A_NA6 Gender ASN Age
*missing for A for SD, PR, NA, Gender, Age, ASN*
misschk A_SD1_R-A_PR4_R A_NA1-A_NA6 Gender ASN Age

*PRO-RATING*
*use to create total scores for each character*
*creating variables for number of valid data points prevents creating mean when less than three points are available*

*Sam NT social distance prorating*
*8 questions in social distance scale*
egen SSDMean=rowmean(S_SD1_R S_SD2 S_SD3 S_SD4_R S_SD5 S_SD6_R S_SD7 S_SD8_R)
egen SSDValid=rownonmiss(S_SD1_R S_SD2 S_SD3 S_SD4_R S_SD5 S_SD6_R S_SD7 S_SD8_R)
gen S_SDp = SSDMean*8 if SSDValid >=3
label variable S_SDp "NT (Sam) social distance total"
drop SSDMean SSDValid
*compare to row total without prorating*
egen S_SD = rowtotal (S_SD1_R S_SD2 S_SD3 S_SD4_R S_SD5 S_SD6_R S_SD7 S_SD8_R)
drop S_SD

*Sam NT personal responsibility prorating*
*4 questions in personal responsibility scale*
egen SPRMean=rowmean(S_PR1 S_PR2 S_PR3_R S_PR4_R)
egen SPRValid=rownonmiss(S_PR1 S_PR2 S_PR3_R S_PR4_R)
gen S_PRp = SPRMean*4 if SPRValid >=3
label variable S_PRp "NT (Sam) responsibility total"
drop SPRMean SPRValid
*compare to row total without prorating*
egen S_PR = rowtotal (S_PR1 S_PR2 S_PR3_R S_PR4_R)
drop S_PR

*Sam NT likelihood of bullying prorating*
*5 questions in likelihood of bullying scale*
egen SLBMean=rowmean(S_LB1 S_LB2 S_LB3 S_LB4 S_LB5)
egen SLBValid=rownonmiss(S_LB1 S_LB2 S_LB3 S_LB4 S_LB5)
gen S_LBp = SLBMean*5 if SLBValid >=3
label variable S_LBp "NT (Sam) bullying total"
drop SLBMean SLBValid
*compare to row total without prorating*
egen S_LB = rowtotal (S_LB1 S_LB2 S_LB3 S_LB4 S_LB5)
drop S_LB

*Sam NT negative affect prorating*
*6 questions in negative affect scale*
egen SNAMean=rowmean(S_NA1 S_NA2_R S_NA3 S_NA4 S_NA5_R S_NA6)
egen SNAValid=rownonmiss(S_NA1 S_NA2_R S_NA3 S_NA4 S_NA5_R S_NA6)
gen S_NAp = SNAMean*6 if SNAValid >=3
label variable S_NAp "NT (Sam) affect total"
drop SNAMean SNAValid
*compare to row total without prorating*
egen S_NA = rowtotal (S_NA1 S_NA2_R S_NA3 S_NA4 S_NA5_R S_NA6)
drop S_NA

*order Sam totals after demographics*
order S_SDp S_PRp S_LBp S_NAp, after (ASNO_Quality)

*for descriptive table*
sum S_SDp
sum S_PRp
sum S_NAp

*prorating for Alex ASD totals*
egen ASDMean=rowmean(A_SD1_R A_SD2 A_SD3 A_SD4_R A_SD5 A_SD6_R A_SD7 A_SD8_R)
egen ASDValid=rownonmiss(A_SD1_R A_SD2 A_SD3 A_SD4_R A_SD5 A_SD6_R A_SD7 A_SD8_R)
gen A_SDp = ASDMean*8 if ASDValid >=3
label variable A_SDp "ASD (Alex) social distance total"
drop ASDMean ASDValid

egen APRMean=rowmean(A_PR1 A_PR2 A_PR3_R A_PR4_R)
egen APRValid=rownonmiss(A_PR1 A_PR2 A_PR3_R A_PR4_R)
gen A_PRp = APRMean*4 if APRValid >=3
label variable A_PRp "ASD (Alex) responsibility total"
drop APRMean APRValid

egen ALBMean=rowmean(A_LB1 A_LB2 A_LB3 A_LB4 A_LB5)
egen ALBValid=rownonmiss(A_LB1 A_LB2 A_LB3 A_LB4 A_LB5)
gen A_LBp = ALBMean*5 if ALBValid >=3
label variable A_LBp "ASD (Alex) bullying total"
drop ALBMean ALBValid

egen ANAMean=rowmean(A_NA1 A_NA2_R A_NA3 A_NA4 A_NA5_R A_NA6)
egen ANAValid=rownonmiss(A_NA1 A_NA2_R A_NA3 A_NA4 A_NA5_R A_NA6)
gen A_NAp = ANAMean*6 if ANAValid >=3
label variable A_NAp "ASD (Alex) affect total"
drop ANAMean ANAValid

*order Alex ASD totals after Sam NT totals*
order A_SDp A_PRp A_LBp A_NAp, after (S_NAp)

*table of mean scores for A questions by disclosure condition*
tab AASD, sum(A_SDp)
tab AASD, sum(A_PRp)
tab AASD, sum(A_LBp)
tab AASD, sum(A_NAp)

*prorating for George ADHD totals*
egen GSDMean=rowmean(G_SD1_R G_SD2 G_SD3 G_SD4_R G_SD5 G_SD6_R G_SD7 G_SD8_R)
egen GSDValid=rownonmiss(G_SD1_R G_SD2 G_SD3 G_SD4_R G_SD5 G_SD6_R G_SD7 G_SD8_R)
gen G_SDp = GSDMean*8 if GSDValid >=3
label variable G_SDp "ADHD (George) social distance total"
drop GSDMean GSDValid

egen GPRMean=rowmean(G_PR1 G_PR2 G_PR3_R G_PR4_R)
egen GPRValid=rownonmiss(G_PR1 G_PR2 G_PR3_R G_PR4_R)
gen G_PRp = GPRMean*4 if GPRValid >=3
label variable G_PRp "ADHD (George) responsibility total"
drop GPRMean GPRValid

egen GLBMean=rowmean(G_LB1 G_LB2 G_LB3 G_LB4 G_LB5)
egen GLBValid=rownonmiss(G_LB1 G_LB2 G_LB3 G_LB4 G_LB5)
gen G_LBp = GLBMean*5 if GLBValid >=3
label variable G_LBp "ADHD (George) bullying total"
drop GLBMean GLBValid

egen GNAMean=rowmean(G_NA1 G_NA2_R G_NA3 G_NA4 G_NA5_R G_NA6)
egen GNAValid=rownonmiss(G_NA1 G_NA2_R G_NA3 G_NA4 G_NA5_R G_NA6)
gen G_NAp = GNAMean*6 if GNAValid >=3
label variable G_NAp "ADHD (George) affect total"
drop GNAMean GNAValid

*order George totals after Alex totals*
order G_SDp G_PRp G_LBp G_NAp, after (A_NAp)

*table of mean scores for A questions by disclosure condition*
tab GADHD, sum(G_SDp)
tab GADHD, sum(G_PRp)
tab GADHD, sum(G_LBp)
tab GADHD, sum(G_NAp)

/*
*look at missing data for new totals*
misschk  S_SDp S_PRp S_LBp S_NAp A_SDp A_PRp A_LBp A_NAp G_SDp G_PRp G_LBp G_NAp
9 observations (children) have missing data, out of 250:
Pattern: 

1 x S_PRp S_LBp A_LBp
1 x S_LBp A_LBp
1 x S_LBp
1 x G_PRp G_LBp
5 x G_NAp
* code these as missing - 
* For Alex (ASD) 4 DV scales - 250 x 4 = 1000 scale totals, of which 2 have data missing.*

*if missing here, means fewer than 3 data points available in each scale*
*/


*GENERATING CONTACT SCORES*
*QUANTITY:*
*use ASNO_Time only since ASNO_Who not clear scale*
rename ASNO_Time Quantity
*Quantity of contact score range 0-4, with 4 being most contact and 0 being no contact (NOT missing)*
label variable Quantity "Quantity contact"

*QUALITY:*
*use ASNO_Quality*
*BUT - bear in mind will have info from both ASN=Yes and ASN=No*
rename ASNO_Quality Quality
*Quality of contact score range 0-5, with 5 being highest quality and 0 being no contact (NOT missing)*

*will also want to look at ASN=1 i.e. child has special needs - 29/250 said yes, 216/250 said no*

/*
*check missing data*
misschk Quantity
*5 scores missing for Quantity - 2%*
misschk Quality
*7 scores missing for Quality - 2.8%*
*12/(2x250) -> 2.4% missing data for 2 contact measures*
*alt: condense (4 scores overlap so 8 children have missing data for qual and/or quan)*
*/

*GRAPHS*
*check normality continuous variables - total scores*
*all probably ok*
/*SD possible range 8-40
PR possible range 4-20
LB possible range 5-20
NA possible range 6-30

hist S_SDp
*negative skew*
hist S_PRp
*ok*
hist S_LBp
*some extreme high values*
hist S_NAp
*some extreme low values*
sktest S_SDp S_PRp S_LBp S_NAp
*formal test for skew and kurtosis suggests S_SDp S_LBp S_NAp non-normal*

hist A_SDp
*negative skew*
hist A_PRp
*weird!*
hist A_LBp
*flat at low end*
hist A_NAp
*ok*
sktest A_SDp A_PRp A_LBp A_NAp
*formal test suggests A_SDp A_LBp non-normal*

hist G_SDp
*peak at low end*
hist G_PRp
*weird!*
hist G_LBp
*peak at high end*
hist G_NAp

sktest  G_SDp G_PRp G_LBp G_NAp
*suggests G_SDp G_LBp G_NAp non-normal*
*/

*RECODE GENDER*
*given only 2 p reported Gender as 'other', recode these as missing*
replace Gender=. if Gender==3

*split by year group*
generate AgeGroup = Age>=14
order AgeGroup, after(Age)
label define age 0 "Y7" 1 "Y10"
label values AgeGroup age
tab AgeGroup, sum(Age)

*GEN OVERALL DISCLOSURE, NONDISCLOSURE CONDITIONS *
gen disclosure=.
replace disclosure=A_LBp if AASD==1
replace disclosure=G_LBp if AASD==0

gen nondisclosure=.
replace nondisclosure=A_LBp if AASD==0
replace nondisclosure=G_LBp if AASD==1


*diff between NT and ASD?*
ttest S_SDp= A_SDp
ttest S_PRp= A_PRp
ttest S_LBp= A_LBp
ttest S_NAp= A_NAp
*all sig difference*

*********SEE PRELIM ASD.DO FOR TRANSFORMING & REMOVING OUTLIERS FROM SCALES FOR ALEX****************************************

